﻿Option Strict On
Partial Public Class MainPage
    Inherits UserControl

    Public Sub New()
        InitializeComponent()
    End Sub
    Dim myMouseCaputer As Boolean
    Dim myYPos As Double
    Dim myXPos As Double
    Dim myYDropPos As Double

    Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles Me.Loaded
        AddHandler Image1.MouseLeftButtonUp, AddressOf Image1Dropped
        AddHandler Image1.MouseLeftButtonDown, AddressOf Image1Larged
    End Sub

    Private Sub Image1_MouseLeftButtonDown(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Image1.MouseLeftButtonDown
        Image1.Cursor = Cursors.Hand
        Dim myImage As Image = DirectCast(sender, Image)
        myYPos = e.GetPosition(Nothing).Y
        myXPos = e.GetPosition(Nothing).X
        myMouseCaputer = True
        myImage.CaptureMouse()
    End Sub

    Private Sub Image1_MouseLeftButtonUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles Image1.MouseLeftButtonUp
        Image1.Cursor = Cursors.Arrow
        Dim myImage As Image = DirectCast(sender, Image)
        myMouseCaputer = False
        myImage.ReleaseMouseCapture()
        myYDropPos = myYPos
    End Sub


    Private Sub Image1_MouseMove(ByVal sender As Object, ByVal e As System.Windows.Input.MouseEventArgs) Handles Image1.MouseMove
        Dim myImage As Image = DirectCast(sender, Image)
        If myMouseCaputer = True Then
            Dim myVertical As Double = e.GetPosition(Nothing).Y - myYPos
            Dim myHorizontal As Double = e.GetPosition(Nothing).X - myXPos
            Dim myNewTop As Double = myVertical + DirectCast(myImage.GetValue(Canvas.TopProperty), Double)
            Dim myNewLeft As Double = myHorizontal + DirectCast(myImage.GetValue(Canvas.LeftProperty), Double)
            myImage.SetValue(Canvas.TopProperty, myNewTop)
            myImage.SetValue(Canvas.LeftProperty, myNewLeft)
            myYPos = e.GetPosition(Nothing).Y
            myXPos = e.GetPosition(Nothing).X
        End If
    End Sub

    Private Sub Image1Dropped(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        If myYDropPos > 300 Then
            VisualStateManager.GoToState(Me, "ImageSmall", True)
            Dim myCP As Point = e.GetPosition(Target)
            myCP.X = myCP.X / Target.ActualWidth
            myCP.Y = myCP.Y / Target.ActualHeight
            myRippleEffect.Center = myCP
            RippleStoryboard.Begin()
        Else
            VisualStateManager.GoToState(Me, "ImageLarge", True)
        End If
    End Sub

    Private Sub Image1Larged(ByVal sender As Object, ByVal e As MouseButtonEventArgs)
        If myYDropPos < 300 Then
            Exit Sub
        Else
            VisualStateManager.GoToState(Me, "ImageLarge", True)
        End If
    End Sub

   
End Class